"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _row = _interopRequireDefault(require("antd/lib/row"));

var _divider = _interopRequireDefault(require("antd/lib/divider"));

var _button = _interopRequireDefault(require("antd/lib/button"));

var _col = _interopRequireDefault(require("antd/lib/col"));

var _cascader = _interopRequireDefault(require("antd/lib/cascader"));

var _inputNumber = _interopRequireDefault(require("antd/lib/input-number"));

var _select = _interopRequireDefault(require("antd/lib/select"));

var _input = _interopRequireDefault(require("antd/lib/input"));

var _treeSelect = _interopRequireDefault(require("antd/lib/tree-select"));

var _datePicker = _interopRequireDefault(require("antd/lib/date-picker"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _components = require("components");

var _icons = require("@ant-design/icons");

var _compatible = require("@ant-design/compatible");

require("@ant-design/compatible/assets/index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var FormItem = _compatible.Form.Item;
var RangePicker = _datePicker["default"].RangePicker,
    MonthPicker = _datePicker["default"].MonthPicker;
var SHOW_PARENT = _treeSelect["default"].SHOW_PARENT;
var InputGroup = _input["default"].Group;
var filterStyle = {
  style: {
    marginBottom: 16
  }
};
var formItemLayout = {
  labelCol: {
    span: 6
  },
  wrapperCol: {
    span: 18
  }
};
var Option = _select["default"].Option;

var OrderFilterUnExpand = function OrderFilterUnExpand(_ref) {
  var filterItems = _ref.filterItems,
      onFilterChange = _ref.onFilterChange,
      isExpand = _ref.isExpand,
      _ref$form = _ref.form,
      getFieldDecorator = _ref$form.getFieldDecorator,
      getFieldsValue = _ref$form.getFieldsValue,
      setFieldsValue = _ref$form.setFieldsValue,
      expand = _ref.expand,
      noExpand = _ref.noExpand,
      noExpandButton = _ref.noExpandButton;
  var filterItemsDealed = filterItems;

  var handleFields = function handleFields(fields) {
    var _loop = function _loop(key) {
      var field = fields[key]; // 处理日期类型

      var keySel = filterItems.filter(function (val) {
        return val.id == key || val.id1 == key || val.id2 == key;
      });

      if (keySel[0] && keySel[0].type == 'dateRule' && _.isArray(fields[key]) && fields[key].length > 0) {
        var timeStartValue = fields[key][0].valueOf();
        var timeEndValue = fields[key][1].valueOf();
        var timeStartKey = key + "Start";
        var timeEndKey = key + "End";
        fields[timeStartKey] = timeStartValue;
        fields[timeEndKey] = timeEndValue;
        delete fields[key];
      } // 删除请求中为空的对象


      if (keySel[0].type != 'numberBetween' && !field || _.isString(field) && field.replace(/(^\s*)|(\s*$)/g, "").length == 0 || _.isUndefined(field) || _.isNull(field) || _.isArray(field) && field.length === 0) {
        delete fields[key];
        return "continue";
      }
    };

    for (var key in fields) {
      var _ret = _loop(key);

      if (_ret === "continue") continue;
    }

    return fields;
  };

  var handleSubmit = function handleSubmit() {
    var fields = getFieldsValue();
    fields = handleFields(fields);
    onFilterChange(fields);
  };

  var handleReset = function handleReset() {
    var fields = getFieldsValue();

    for (var item in fields) {
      if ({}.hasOwnProperty.call(fields, item)) {
        if (fields[item] instanceof Array) {
          fields[item] = [];
        } else {
          fields[item] = undefined;
        }
      }
    }

    setFieldsValue(fields);
    handleSubmit();
  };

  var handleChange = function handleChange(key, values) {
    var fields = getFieldsValue();
    fields[key] = values;
    fields = handleFields(fields);
    onFilterChange(fields);
  };

  var dateChange = function dateChange(date, dateString) {
    console.log(date, dateString);
  };

  var getFilterItemCol = function getFilterItemCol(filterItems) {
    var result = filterItems.map(function (filterItem, index) {
      return /*#__PURE__*/_react["default"].createElement(_col["default"], {
        key: index,
        span: 8,
        style: {
          display: isExpand || index < 2 ? 'inline-block' : 'none'
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        id: "parent".concat(index)
      }, /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
        label: filterItem.title
      }, formItemLayout, {
        style: {
          minHeight: 40
        }
      }), filterItem.type == 'input' && getFieldDecorator("".concat(filterItem.id), {
        initialValue: filterItem.defaultValue
      })( /*#__PURE__*/_react["default"].createElement(_input["default"], {
        placeholder: filterItem.placeholder,
        onPressEnter: handleSubmit
      })), filterItem.type == 'inputRange' && /*#__PURE__*/_react["default"].createElement(InputGroup, {
        compact: true
      }, getFieldDecorator("".concat(filterItem.id, "Start"), {})( /*#__PURE__*/_react["default"].createElement(_input["default"], {
        style: {
          width: '40%',
          textAlign: 'center'
        },
        placeholder: filterItem.placeholder instanceof Array ? filterItem.placeholder[0] : 'Minimum',
        onPressEnter: handleSubmit
      })), /*#__PURE__*/_react["default"].createElement(_input["default"], {
        style: {
          width: '20%',
          textAlign: 'center',
          pointerEvents: 'none',
          backgroundColor: '#fff'
        },
        placeholder: "~",
        disabled: true
      }), getFieldDecorator("".concat(filterItem.id, "End"), {})( /*#__PURE__*/_react["default"].createElement(_input["default"], {
        style: {
          width: '40%',
          textAlign: 'center'
        },
        placeholder: filterItem.placeholder instanceof Array ? filterItem.placeholder[1] : 'Maximum',
        onPressEnter: handleSubmit
      }))), filterItem.type === 'inputNumber' && getFieldDecorator("".concat(filterItem.id), {
        initialValue: filterItem.defaultValue
      })( /*#__PURE__*/_react["default"].createElement(_inputNumber["default"], _extends({
        placeholder: filterItem.placeholder,
        onPressEnter: handleSubmit,
        step: 0.01,
        precision: 2
      }, filterItem, {
        style: {
          width: '100%'
        }
      }))), filterItem.type == 'select' && getFieldDecorator("".concat(filterItem.id), {
        initialValue: filterItem.defaultValue
      })( /*#__PURE__*/_react["default"].createElement(_select["default"], {
        initialValue: filterItem.defaultValue,
        allowClear: true,
        style: {
          width: '100%'
        },
        showSearch: filterItem.showSearch,
        filterOption: function filterOption(input, option) {
          return option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0;
        },
        getPopupContainer: function getPopupContainer() {
          return document.getElementById("parent".concat(index));
        }
      }, getOptions(filterItem.options))), filterItem.type === 'treeSelect' && getFieldDecorator("".concat(filterItem.id), {
        initialValue: filterItem.defaultValue
      })( /*#__PURE__*/_react["default"].createElement(_treeSelect["default"], {
        initialValue: filterItem.defaultValue,
        treeData: filterItem.options,
        treeCheckable: filterItem.checkable ? filterItem.checkable : false,
        maxTagCount: filterItem.maxTagCount ? filterItem.maxTagCount : 1,
        showCheckedStrategy: SHOW_PARENT,
        searchPlaceholder: filterItem.searchPlaceholder,
        placeholder: filterItem.placeholder,
        style: {
          width: '100%'
        },
        getPopupContainer: function getPopupContainer() {
          return document.getElementById("parent".concat(index));
        }
      })), filterItem.type == 'dateRule' && getFieldDecorator("".concat(filterItem.id), {
        initialValue: filterItem !== null && filterItem !== void 0 && filterItem.bdTime ? [(0, _moment["default"])(filterItem.bdTime || '', filterItem.dateFormat || "YYYY/MM/DD"), (0, _moment["default"])(filterItem.edTime || '', filterItem.dateFormat || "YYYY/MM/DD")] : ''
      })( /*#__PURE__*/_react["default"].createElement(RangePicker, {
        style: {
          width: '100%'
        },
        showTime: true,
        format: filterItem.dateFormat || "YYYY/MM/DD",
        onChange: dateChange
      })), filterItem.type == 'date' && getFieldDecorator("".concat(filterItem.id), {})( /*#__PURE__*/_react["default"].createElement(_datePicker["default"], {
        style: {
          width: '100%'
        },
        onChange: dateChange
      })), filterItem.type == 'month' && getFieldDecorator("".concat(filterItem.id), {
        initialValue: filterItem.defaultValue
      })( /*#__PURE__*/_react["default"].createElement(MonthPicker, _extends({
        style: {
          width: '100%'
        },
        onChange: dateChange
      }, filterItem))), filterItem.type === 'numberBetween' && /*#__PURE__*/_react["default"].createElement(InputGroup, {
        compact: true,
        style: {
          width: '100%',
          display: 'flex'
        }
      }, getFieldDecorator("".concat(filterItem.id1), {
        initialValue: filterItem.defaultValue1
      })( /*#__PURE__*/_react["default"].createElement(_inputNumber["default"], {
        style: {
          width: '45%',
          textAlign: 'center'
        },
        step: 0.01,
        precision: 2,
        min: 0,
        placeholder: filterItem.placeholder1 ? filterItem.placeholder1 : ''
      })), /*#__PURE__*/_react["default"].createElement(_input["default"], {
        style: {
          width: '10%',
          borderRight: 0,
          pointerEvents: 'none',
          backgroundColor: '#fff'
        },
        placeholder: "~",
        disabled: true
      }), getFieldDecorator("".concat(filterItem.id2), {
        initialValue: filterItem.defaultValue2
      })( /*#__PURE__*/_react["default"].createElement(_inputNumber["default"], {
        style: {
          width: '45%',
          textAlign: 'center'
        },
        step: 0.01,
        precision: 2,
        min: 0,
        placeholder: filterItem.placeholder2 ? filterItem.placeholder2 : ''
      }))), filterItem.type == 'cascader' && getFieldDecorator("".concat(filterItem.id), {})( /*#__PURE__*/_react["default"].createElement(_cascader["default"], {
        style: {
          width: '100%'
        },
        options: filterItem.options,
        placeholder: filterItem.placeholder
      })))));
    });
    return result;
  }; // 处理下拉选项


  var getOptions = function getOptions(value) {
    return value.map(function (option) {
      return /*#__PURE__*/_react["default"].createElement(Option, {
        value: option.value,
        key: "".concat(Math.random())
      }, option.name);
    });
  };

  var filterItemCols = getFilterItemCol(filterItemsDealed);
  console.info(noExpandButton);
  return /*#__PURE__*/_react["default"].createElement(_row["default"], _extends({
    gutter: 24
  }, filterStyle), filterItemCols, /*#__PURE__*/_react["default"].createElement(_col["default"], {
    span: 8,
    style: {
      textAlign: 'left'
    }
  }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    type: "primary",
    onClick: handleSubmit
  }, "\u67E5\u8BE2"), /*#__PURE__*/_react["default"].createElement(_divider["default"], {
    type: "vertical"
  }), /*#__PURE__*/_react["default"].createElement(_button["default"], {
    type: "ghost",
    onClick: handleReset
  }, "\u91CD\u7F6E"), /*#__PURE__*/_react["default"].createElement(_divider["default"], {
    type: "vertical"
  }), " ", _.isEmpty(noExpandButton) && !isExpand && /*#__PURE__*/_react["default"].createElement("a", {
    style: {
      marginRight: 40
    },
    onClick: expand
  }, "\u5C55\u5F00 ", /*#__PURE__*/_react["default"].createElement(_icons.DownOutlined, null)), _.isEmpty(noExpandButton) && isExpand && /*#__PURE__*/_react["default"].createElement("a", {
    style: {
      marginRight: 40
    },
    onClick: noExpand
  }, "\u6536\u8D77 ", /*#__PURE__*/_react["default"].createElement(_icons.UpOutlined, null))));
};

OrderFilterUnExpand.propTypes = {
  form: _propTypes["default"].object,
  filter: _propTypes["default"].object,
  onFilterChange: _propTypes["default"].func
};

var _default = _compatible.Form.create({
  onFieldsChange: function onFieldsChange(props, changedFields) {
    if (props.onChange) {
      props.onChange(changedFields);
    }
  }
})(OrderFilterUnExpand);

exports["default"] = _default;