"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _popover = _interopRequireDefault(require("antd/lib/popover"));

var _menu = _interopRequireDefault(require("antd/lib/menu"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _icons = require("@ant-design/icons");

var _compatible = require("@ant-design/compatible");

var _classnames = _interopRequireDefault(require("classnames"));

var _Header = _interopRequireDefault(require("./Header.less"));

var _Menu2 = _interopRequireDefault(require("./Menu"));

var _umi = require("umi");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var SubMenu = _menu["default"].SubMenu;

var Header = function Header(_ref) {
  var user = _ref.user,
      tenant = _ref.tenant,
      logout = _ref.logout,
      switchSider = _ref.switchSider,
      siderFold = _ref.siderFold,
      isNavbar = _ref.isNavbar,
      menuPopoverVisible = _ref.menuPopoverVisible,
      location = _ref.location,
      switchMenuPopover = _ref.switchMenuPopover,
      navOpenKeys = _ref.navOpenKeys,
      changeOpenKeys = _ref.changeOpenKeys,
      menu = _ref.menu,
      rightItemRender = _ref.rightItemRender,
      _ref$kujialeInfo = _ref.kujialeInfo,
      kujialeInfo = _ref$kujialeInfo === void 0 ? {} : _ref$kujialeInfo,
      onClickPerson = _ref.onClickPerson;
  var menusProps = {
    menu: menu,
    siderFold: false,
    darkTheme: false,
    isNavbar: isNavbar,
    handleClickNavMenu: switchMenuPopover,
    location: location,
    navOpenKeys: navOpenKeys,
    changeOpenKeys: changeOpenKeys
  };

  var handleClickPerson = function handleClickPerson() {
    if (kujialeInfo.isBindingKjl === true || kujialeInfo.isBindingKjl === false) {
      onClickPerson();
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _Header["default"].header,
    style: {
      left: isNavbar ? '0px' : siderFold ? '80px' : '200px'
    }
  }, isNavbar ? /*#__PURE__*/_react["default"].createElement(_popover["default"], {
    placement: "bottomLeft",
    onVisibleChange: switchMenuPopover,
    visible: menuPopoverVisible,
    overlayClassName: _Header["default"].popovermenu,
    trigger: "click",
    content: /*#__PURE__*/_react["default"].createElement(_Menu2["default"], menusProps)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _Header["default"].button
  }, /*#__PURE__*/_react["default"].createElement(_icons.BarsOutlined, null))) : /*#__PURE__*/_react["default"].createElement("div", {
    className: _Header["default"].button,
    onClick: switchSider
  }, /*#__PURE__*/_react["default"].createElement(_compatible.Icon, {
    type: (0, _classnames["default"])({
      'menu-unfold': siderFold,
      'menu-fold': !siderFold
    })
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: _Header["default"].rightWarpper
  }, rightItemRender && rightItemRender(), !rightItemRender && /*#__PURE__*/_react["default"].createElement("a", {
    href: "http://siteadmin.liweijia.com/",
    target: "_blank",
    className: _Header["default"].site
  }, "\u5546\u54C1\u7BA1\u7406"), /*#__PURE__*/_react["default"].createElement(_umi.Link, {
    className: _Header["default"].question,
    to: '/faq'
  }, "\u5E38\u89C1\u95EE\u9898", /*#__PURE__*/_react["default"].createElement(_icons.QuestionCircleOutlined, null)), /*#__PURE__*/_react["default"].createElement("div", {
    className: _Header["default"].tenantName,
    style: {
      marginTop: 13
    }
  }, tenant.displayName), /*#__PURE__*/_react["default"].createElement("div", {
    className: _Header["default"].button
  }, /*#__PURE__*/_react["default"].createElement(_icons.MailOutlined, null)), /*#__PURE__*/_react["default"].createElement(_menu["default"], {
    mode: "horizontal"
  }, /*#__PURE__*/_react["default"].createElement(SubMenu, {
    style: {
      "float": 'right'
    },
    title: /*#__PURE__*/_react["default"].createElement("span", {
      onClick: function onClick() {
        return handleClickPerson();
      }
    }, user.name, kujialeInfo.isBindingKjl === true ? /*#__PURE__*/_react["default"].createElement("i", {
      className: _Header["default"].kujiale
    }) : kujialeInfo.isBindingKjl === false ? /*#__PURE__*/_react["default"].createElement("i", {
      className: _Header["default"].nokujiale
    }) : /*#__PURE__*/_react["default"].createElement(_icons.SyncOutlined, {
      spin: true
    }))
  }, /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
    key: "person",
    disabled: !(kujialeInfo.isBindingKjl === true || kujialeInfo.isBindingKjl === false),
    onClick: function onClick() {
      return handleClickPerson();
    }
  }, "\u4E2A\u4EBA\u4E2D\u5FC3"), /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
    key: "logout",
    onClick: function onClick() {
      return logout();
    }
  }, "\u6CE8\u9500")))));
};

Header.propTypes = {
  menu: _propTypes["default"].array,
  user: _propTypes["default"].object,
  logout: _propTypes["default"].func,
  switchSider: _propTypes["default"].func,
  siderFold: _propTypes["default"].bool,
  isNavbar: _propTypes["default"].bool,
  menuPopoverVisible: _propTypes["default"].bool,
  location: _propTypes["default"].object,
  switchMenuPopover: _propTypes["default"].func,
  navOpenKeys: _propTypes["default"].array,
  changeOpenKeys: _propTypes["default"].func,
  rightItemRender: _propTypes["default"].func
};
var _default = Header;
exports["default"] = _default;