"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _menu = _interopRequireDefault(require("antd/lib/menu"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _compatible = require("@ant-design/compatible");

var _reactRouterDom = require("react-router-dom");

var _utils = require("utils");

var _pathToRegexp = _interopRequireDefault(require("path-to-regexp"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var Menus = function Menus(_ref) {
  var siderFold = _ref.siderFold,
      darkTheme = _ref.darkTheme,
      handleClickNavMenu = _ref.handleClickNavMenu,
      navOpenKeys = _ref.navOpenKeys,
      changeOpenKeys = _ref.changeOpenKeys,
      menu = _ref.menu,
      location = _ref.location;
  // 生成树状
  var menuTree = (0, _utils.arrayToTree)(menu.filter(function (_) {
    return _.pid !== '-1';
  }), 'id', 'pid');
  var levelMap = {};

  var refreshThisPage = function refreshThisPage() {
    //  window.location.href=location.pathname
    return false;
  }; // 递归生成菜单


  var getMenus = function getMenus(menuTreeN, siderFoldN) {
    return menuTreeN.map(function (item) {
      if (item.children) {
        if (item.pid) {
          levelMap[item.id] = item.pid;
        }

        return /*#__PURE__*/_react["default"].createElement(_menu["default"].SubMenu, {
          key: item.id,
          title: /*#__PURE__*/_react["default"].createElement("span", null, item.icon && /*#__PURE__*/_react["default"].createElement(_compatible.Icon, {
            type: item.icon
          }), (!siderFoldN || !menuTree.includes(item)) && item.name)
        }, getMenus(item.children, siderFoldN));
      }

      return /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
        key: item.id
      }, item.route === location.pathname && /*#__PURE__*/_react["default"].createElement("div", {
        onClick: function onClick() {
          refreshThisPage();
        }
      }, item.icon && /*#__PURE__*/_react["default"].createElement(_compatible.Icon, {
        type: item.icon
      }), item.name), item.route !== location.pathname && /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Link, {
        to: item.route || '#'
      }, item.icon && /*#__PURE__*/_react["default"].createElement(_compatible.Icon, {
        type: item.icon
      }), item.name));
    });
  };

  var menuItems = getMenus(menuTree, siderFold); // 保持选中

  var getAncestorKeys = function getAncestorKeys(key) {
    var map = {};

    var getParent = function getParent(index) {
      var result = [String(levelMap[index])];

      if (levelMap[result[0]]) {
        result.unshift(getParent(result[0])[0]);
      }

      return result;
    };

    for (var index in levelMap) {
      if ({}.hasOwnProperty.call(levelMap, index)) {
        map[index] = getParent(index);
      }
    }

    return map[key] || [];
  };

  var onOpenChange = function onOpenChange(openKeys) {
    var latestOpenKey = openKeys.find(function (key) {
      return !navOpenKeys.includes(key);
    });
    var latestCloseKey = navOpenKeys.find(function (key) {
      return !openKeys.includes(key);
    });
    var nextOpenKeys = [];

    if (latestOpenKey) {
      nextOpenKeys = getAncestorKeys(latestOpenKey).concat(latestOpenKey);
    }

    if (latestCloseKey) {
      nextOpenKeys = getAncestorKeys(latestCloseKey);
    }

    changeOpenKeys(nextOpenKeys);
  };

  var menuProps = !siderFold ? {
    onOpenChange: onOpenChange,
    openKeys: navOpenKeys
  } : {}; // 寻找选中路由

  var currentMenu;
  var defaultSelectedKeys;

  var _iterator = _createForOfIteratorHelper(menu),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var item = _step.value;

      if (item.route && (0, _pathToRegexp["default"])(item.route).exec(location.pathname)) {
        currentMenu = item;
        break;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  var getPathArray = function getPathArray(array, current, pid, id) {
    var result = [String(current[id])];

    var getPath = function getPath(item) {
      if (item && item[pid]) {
        result.unshift(String(item[pid]));
        getPath((0, _utils.queryArray)(array, item[pid], id));
      }
    };

    getPath(current);
    return result;
  };

  if (currentMenu) {
    defaultSelectedKeys = getPathArray(menu, currentMenu, 'pid', 'id');
  }

  if (!defaultSelectedKeys) {
    defaultSelectedKeys = ['11'];
  }

  return /*#__PURE__*/_react["default"].createElement(_menu["default"], _extends({}, menuProps, {
    mode: "inline",
    theme: darkTheme ? 'dark' : 'light',
    onClick: handleClickNavMenu,
    selectedKeys: defaultSelectedKeys,
    inlineIndent: "20"
  }), menuItems);
};

Menus.propTypes = {
  menu: _propTypes["default"].array,
  siderFold: _propTypes["default"].bool,
  darkTheme: _propTypes["default"].bool,
  handleClickNavMenu: _propTypes["default"].func,
  navOpenKeys: _propTypes["default"].array,
  changeOpenKeys: _propTypes["default"].func,
  location: _propTypes["default"].object
};
var _default = Menus;
exports["default"] = _default;