"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _button = _interopRequireDefault(require("antd/lib/button"));

var _datePicker = _interopRequireDefault(require("antd/lib/date-picker"));

var _input = _interopRequireDefault(require("antd/lib/input"));

var _col = _interopRequireDefault(require("antd/lib/col"));

var _select = _interopRequireDefault(require("antd/lib/select"));

var _compatible = require("@ant-design/compatible");

require("@ant-design/compatible/assets/index.css");

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _http = require("http");

var _LwjFilterForm = _interopRequireDefault(require("./LwjFilterForm.less"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var FormItem = _compatible.Form.Item;
var Option = _select["default"].Option;

var FilterForm = function FilterForm(_ref) {
  var filterItems = _ref.filterItems,
      getBackData = _ref.getBackData,
      _ref$form = _ref.form,
      getFieldDecorator = _ref$form.getFieldDecorator,
      getFieldsValue = _ref$form.getFieldsValue,
      setFieldsValue = _ref$form.setFieldsValue;
  // 表单项布局
  var formItemLayout = {
    labelCol: {
      xs: {
        span: 24
      },
      sm: {
        span: 8
      }
    },
    wrapperCol: {
      xs: {
        span: 24
      },
      sm: {
        span: 16
      }
    }
  };

  var getItems = function getItems(filterItems) {
    return filterItems.map(function (value) {
      return /*#__PURE__*/_react["default"].createElement(_col["default"], {
        span: 8,
        key: value.id
      }, getItem(value));
    });
  };

  var getItem = function getItem(value) {
    switch (value.type) {
      case 'input':
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: value.title
        }, formItemLayout), getFieldDecorator(value.id, {})( /*#__PURE__*/_react["default"].createElement(_input["default"], {
          placeholder: value.placeholder
        })));

      case 'select':
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: value.title
        }, formItemLayout), getFieldDecorator(value.id, {
          initialValue: value.defaultValue
        })( /*#__PURE__*/_react["default"].createElement(_select["default"], {
          initialValue: value.defaultValue
        }, getOptions(value.options))));

      case 'date':
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: value.title
        }, formItemLayout), getFieldDecorator(value.bid, {
          initialValue: value.defaultValue
        })( /*#__PURE__*/_react["default"].createElement(_datePicker["default"], {
          onChange: dateChange,
          showTime: true,
          format: value.format || "YYYY/MM/DD",
          style: {
            width: 160
          }
        })), "\u81F3", getFieldDecorator(value.eid, {
          initialValue: value.defaultValue
        })( /*#__PURE__*/_react["default"].createElement(_datePicker["default"], {
          showTime: true,
          format: value.format || "YYYY/MM/DD",
          style: {
            width: 160
          }
        })));
    }
  };

  var dateChange = function dateChange(value) {
    console.log(value);
  }; // 处理下拉选项


  var getOptions = function getOptions(value) {
    return value.map(function (option) {
      return /*#__PURE__*/_react["default"].createElement(Option, {
        value: option.value,
        key: option.value
      }, option.name);
    });
  };

  var pullOut = function pullOut() {
    var fields = getFieldsValue();
    getBackData(fields);
  };

  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_compatible.Form, {
    inline: 'true'
  }, getItems(filterItems), /*#__PURE__*/_react["default"].createElement(_col["default"], {
    span: 8,
    className: _LwjFilterForm["default"].center
  }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    type: 'primary',
    onClick: pullOut
  }, "\u641C\u7D22"))));
};

var _default = _compatible.Form.create()(FilterForm);

exports["default"] = _default;